TOX: DOC verify 56/21256/8
authorPeter Mikus <pmikus@cisco.com>
Tue, 13 Aug 2019 10:10:50 +0000 (10:10 +0000)
committerVratko Polak <vrpolak@cisco.com>
Thu, 15 Aug 2019 10:20:31 +0000 (10:20 +0000)
Signed-off-by: Peter Mikus <pmikus@cisco.com>
Change-Id: Ifa4de8e60742f5c4cf4c2f377692313e23f9983b

resources/libraries/bash/entry/check/doc_verify.sh [new file with mode: 0644]
resources/libraries/bash/function/common.sh
tox.ini

diff --git a/resources/libraries/bash/entry/check/doc_verify.sh b/resources/libraries/bash/entry/check/doc_verify.sh
new file mode 100644 (file)
index 0000000..50b3d2d
--- /dev/null
@@ -0,0 +1,59 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2019 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -xeuo pipefail
+
+# This file should be executed from tox, as the assumend working directory
+# is different from where this file is located.
+# This file does not have executable flag nor shebang,
+# to dissuade non-tox callers.
+
+# "set -eu" handles failures from the following two lines.
+BASH_CHECKS_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
+BASH_FUNCTION_DIR="$(readlink -e "${BASH_CHECKS_DIR}/../../function")"
+source "${BASH_FUNCTION_DIR}/common.sh" || {
+    echo "Source failed." >&2
+    exit 1
+}
+
+common_dirs || die
+log_file="$(pwd)/doc_verify.log" || die
+
+# Pre-cleanup.
+rm -f "${log_file}" || die
+rm -f "${DOC_GEN_DIR}/csit.docs.tar.gz" || die
+rm -rf "${DOC_GEN_DIR}/_build" || die
+
+# Documentation generation.
+# Here we do store only stderr to file while stdout (inlcuding Xtrace) is
+# printed to console. This way we can track increased errors in future.
+# We do not need to do trap as the env will be closed after tox finished the
+# task.
+exec 3>&1 || die
+export BASH_XTRACEFD="3" || die
+
+pushd "${DOC_GEN_DIR}" || die
+source ./run_doc.sh ${GERRIT_BRANCH:-local} 2> ${log_file} || true
+popd || die
+
+if [[ ! -f "${log_file}" ]] || [[ -s "${log_file}" ]]; then
+    # Output file not exists or is non empty.
+    warn
+    warn "Doc verify checker: FAIL"
+    exit 1
+fi
+
+warn
+warn "Doc verify checker: PASS"
index 13976ae..4352724 100644 (file)
@@ -239,6 +239,9 @@ function common_dirs () {
     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
         die "Readlink failed."
     }
+    DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
+        die "Readlink failed."
+    }
     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
         die "Readlink failed."
     }
diff --git a/tox.ini b/tox.ini
index 2aa1877..b59abc2 100644 (file)
--- a/tox.ini
+++ b/tox.ini
@@ -25,7 +25,9 @@
 # will execute only checks defined in "pylint" tox environment.
 
 [tox]
-envlist = new_line_length, line_length, autogen, pylint, tc_naming, tc_coverage
+envlist = new_line_length, line_length, autogen, pylint, tc_naming, tc_coverage,
+    doc_verify
+
 # The following is needed as tox requires setup.py by default.
 skipsdist = true
 # Just a shorthand to avoid long lines.
@@ -72,6 +74,11 @@ whitelist_externals = /bin/bash
 # Coverage is not needed to be voting.
 commands = bash -c "bash {[tox]checker_dir}/tc_coverage.sh || true"
 
+[testenv:doc_verify]
+# Fix all documentaion error before enabling voting.
+whitelist_externals = /bin/bash
+commands = bash -c "bash {[tox]checker_dir}/doc_verify.sh || true"
+
 # TODO: Migrate current docs check here.
 # TODO: Create voting "pylint violations should not increase" checker.
 # TODO: Create voting checker to reject suites with Force Tags of other suite.